/* 
** XMayday API.
** XMayday.h
** 
** Axene, Inc.  http://www.axene.com/
** Mail troubles to xmayday-api@axene.com
**
** Copyright (c)1997 Axene. All Rights reserved.
** 
*/


#ifndef _XMayday_h_
#define _XMayday_h_

#include <sys/types.h>
#include <stddef.h>

#ifdef __GNUC__
#include <unistd.h>
#endif

/*--- Prototypes ---*/
#ifdef __cplusplus
# define ___PROTO(x) x
#else
# ifdef __STDC__
#  define ___PROTO(x) x
# else
#  define ___PROTO(x) ()
# endif
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>

#ifndef QUIET_MODE

#include <varargs.h>

#ifdef STATIC_DEF
FILE *Xc_log_file = stderr;
void Xc_LogPrintf(format, va_alist)
char *format;
va_dcl
{
 va_list ap;
  
 va_start(ap);
 vfprintf(Xc_log_file, format, ap);
 va_end(ap);
}

#if !defined(___freebsd) && !defined(___NetBSD)
extern char *sys_errlist[];
extern int sys_nerr;
#endif

char *Xc_strerror(errorcode)
int errorcode;
{
 if((errorcode > 0) && (errorcode < sys_nerr))
  return (char *)sys_errlist[errorcode];
 return("Unknow error");
}

#else
extern FILE *Xc_log_file;
extern void Xc_LogPrintf();
extern char *Xc_strerror();
#endif

#define Xc_exit(code) \
do { \
      Xc_LogPrintf("[%s %d] - Exiting with code %d\n", __FILE__, (int)__LINE__, (code)); \
      exit(code); \
} while(0)

#define Xc_TRACE(args) \
do { \
      Xc_LogPrintf("TRACE [%s %d] - ", __FILE__, (int)__LINE__); \
      Xc_LogPrintf args; \
      putc('\n', Xc_log_file); \
} while(0)

#define Xc_WARNING(args) \
do { \
      Xc_LogPrintf("WARNING [%s %d] - ", __FILE__, (int)__LINE__); \
      Xc_LogPrintf args; \
      putc('\n', Xc_log_file); \
} while(0)

#define Xc_SYSERROR(args) \
do { \
      Xc_LogPrintf("SYSERROR [%s %d] - ", __FILE__, (int)__LINE__); \
      Xc_LogPrintf args; \
      Xc_LogPrintf(": %s\n", Xc_strerror(errno)); \
} while(0)

#define Xc_FATAL(args) \
do { \
      Xc_LogPrintf("FATAL ERROR [%s %d] - ", __FILE__, (int)__LINE__); \
      Xc_LogPrintf args; \
      putc('\n', Xc_log_file); \
      Xc_exit(-1); \
} while(0)

#else

#define Xc_exit(code) exit(code)

#define Xc_TRACE(args) \
printf args; \
putchar('\c')

#define Xc_WARNING(args)

#define Xc_SYSERROR(args) Xc_SyserrorAlert args;

#define Xc_FATAL(args) \
do { \
      Xc_LogPrintf("FATAL ERROR - "); \
      Xc_LogPrintf args; \
      putc('\n', Xc_log_file); \
      Xc_exit(-1); \
} while(0)

#endif

#ifndef TRUE
#define TRUE    1
#endif

#ifndef FALSE
#define FALSE   0
#endif

#ifndef NULL
#define NULL    ((void *)0)
#endif

typedef unsigned char boolean;

#endif /* _XMayday_h_ */











